#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#include <dos.h>
#include <string.h>

#include "commdefs.h"
#include "matrix.h"
#include "graph.h"
#include "fileio.h"

extern "C" void initmouse();  // must be called before mouse is used.
extern "C" void showsite();
extern "C" void hidesite();

// sets mouse shape.
extern "C" void Setsight(unsigned int segment,unsigned int offset);
extern "C" void SetHorBound();
extern "C" void SetMousePos();

// variables which contain the state of the mouse:
// position, button-press information.
unsigned int  siteX;
unsigned int  siteY;
unsigned int  buttons;

unsigned int sight[] = {
// sight
	0xFFFF,0xFFFF,0xFFFF,0xCFF3,
	0xE7E7,0xF3CF,0xF99F,0xFC3F,
	0xFC3F,0xF99F,0xF3CF,0xE7E7,
	0xCFF3,0xFFFF,0xFFFF,0xFFFF,
// sight mask
	0xE817,0x8421,0x83C1,0x300C,
	0x1818,0x0C30,0x8661,0x43C2,
	0x43C2,0x8661,0x0C30,0x1818,
	0x300C,0x83C1,0x8421,0xE817,
//sightcursor
	0xFFFF,0xBFFD,0xDFFB,0xEFF7,
	0xF7EF,0xFBDF,0xFDBF,0xFE7F,
	0xFE7F,0xFDBF,0xFBDF,0xF7EF,
	0xEFF7,0xDFFD,0xBFFD,0xFFFF
};


// uncomment for orthogonal projection: (perspective default)
//#define orthogonal 1

#define MOUSE_DELAY 300  // number of cycles from last mouse movement
			 // until mouse,buttons disappear.

#define THETA 0.11 	// (standard : 0.11) angle of rotation (radians)

#define DELAY 10
//#define SHOW_MOUSE_POS 1
void blank_buttons(void);
void show_buttons(void);

inline void  Check_input(BOOLEAN& Xb,BOOLEAN& Yb,BOOLEAN& Zb,
	BOOLEAN& NXb,BOOLEAN& NYb,BOOLEAN& NZb,unsigned sx,unsigned sy);



// default resolution: (x,y)
// note: this must be an even number!
#define DEF_GRID_X 20   // horizontal resolution.
#define DEF_GRID_Y 20   // vertical resolution.
#define UNIT_VALUE 10   // space between selectable points (scale).

class grid {
 public:
  grid();	// default constructor.
void draw(){
	::setcolor(GREEN);
	A_grid->Draw(); };
 private:
  int X_res,Y_res;
  float Zcoordinate;       // z coordinate of grid.
  graph *A_grid,*out_grid; // A_grid is selectable by the mouse,
			   // out_grid is the contruction so far.
};

void main(int argc,char* argv[]){
grid Tgrid;
FILE* fileHandle;
graph **objectlist;
   char filestring[9];
int curpoints,cur_edges,numobjects=1;
// file scaling parameters:
float xscale,yscale,zscale;
 // set up rotation matrices :
      float theta=THETA;	// angle of rotation (radians) (per frame)
       matrix Rx,Ry,Rz,NRx,NRy,NRz;
       matrix MirrorX,Perspect;
       MirrorX.Ymirror();
       Rx.Xrotate(theta);
       Rz.Zrotate(theta);
       Ry.Yrotate(theta);
       NRx.NXrotate(theta);
       NRy.NYrotate(theta);
       NRz.NZrotate(theta);

char outerch; // questions user to go again (y/n)?
int count2=0;  // number of times through outer loop.
// outer do loop ( repeats until user wants to quit);
do {
  // if input file not given on the command line : ask for it.
  // or if user wants to view another file.
   if((argc != 2) || (count2 !=0) ){
	printf(" \n \n please specify input file :");
	scanf("%s", &filestring);
     } else {
      strcpy(filestring,argv[1]);
     };
// open data file for reading:
fileHandle=NULL;
while(fileHandle==NULL){
fileHandle= OpenDataFile(fileHandle,filestring,READ);
  if(fileHandle==NULL){
     printf(" \n \n please specify input file :");
     scanf("%s", &filestring);
   }
}

// read file scaling parameters:
 if(fscanf(fileHandle, "%e", &xscale)){
     printf("%i points in graph \n",curpoints);
     } else {
     printf(" error reading scale factor (float) from file.");
     }
if(fscanf(fileHandle, "%e", &yscale)){
     printf("%i points in graph \n",curpoints);
     } else {
     printf(" error reading scale factor (float) from file.");
     }
if(fscanf(fileHandle, "%e", &zscale)){
     printf("%i points in graph \n",curpoints);
     } else {
     printf(" error reading scale factor (float) from file.");
     }

// allocate space for array of new graph pointers:
   objectlist = (graph**) new graph[numobjects];

   // read number of points and edges for graph object.
   if(fscanf(fileHandle, "%i", &curpoints)){
     printf("%i points in graph \n",curpoints);
     } else {
     printf(" error reading number of points (int) from file.");
     }

// allocate space for the point + edge arrays.
objectlist[0] = new graph(curpoints,0);

// read data from file into graph object:
ReadGraphFileData3dv(fileHandle,objectlist[0],curpoints);

// close file after reading in data:
fclose(fileHandle);

	matrix ThreeXScale;
	ThreeXScale= ThreeXScale.scale(xscale,yscale,zscale);
	objectlist[0]->Apply(ThreeXScale);

 int gdriver = DETECT, gmode, errorcode;
		 //     "y:\\bin\\bc3\\bgi"  "d:\\borlandc\\bgi"
		errorcode = registerbgidriver(EGAVGA_driver);
		::initgraph(&gdriver, &gmode,"");
		errorcode = graphresult();
		if (errorcode != grOk){
		   printf("Graphics error: %s\n", grapherrormsg(errorcode));
		   printf("Press any key to halt:");
		   getch();
		   exit(1);
		}
  // initialize mouse
   initmouse();

 // set mouse's shape
   unsigned int far *siteptr=sight;
   Setsight(FP_SEG(siteptr),FP_OFF(siteptr));

//##   Tgrid.draw();
   show_buttons();
 // turn mouse on
   SetMousePos();
   SetHorBound();
   showsite();

     unsigned long int count=0,mouse_stamp=0,stamp_difference=0;
//     BOOLEAN visible=TRUE;
     char ch='o'; // meaningless char.
//     matrix *which=&NRy,*which2=&NRx,*which3=&NRz;

// copyList holds a copy of original data to be used in
// non- affine transformations.
graph** copyList;
// oldList holds old values of copy list until the new values are computed,
// so as to redraw (and thus erase) the screen image.
graph** oldList;
  oldList = (graph**) new graph[numobjects];
  copyList = (graph**) new graph[numobjects];

// these boolean values indicate which rotation transformations are
// in effect.
BOOLEAN Xb=FALSE,Yb=FALSE,Zb=FALSE,NXb=FALSE,NYb=FALSE,NZb=FALSE;

// default color + line drawing mode:
 ::setwritemode(XOR_PUT);
 ::setcolor(GREEN);

//#ifdef SHOW_MOUSE_POS
unsigned int lastSiteX,lastSiteY;
//#endif
int numOff=1,numOn=1;

 // repeat until termination condition is selected.
while((ch != 'x') && (ch != 'X')){
     if(kbhit()){
       ch=getch();
      };
     // get mouse button and position status.
	    asm push bx
	    asm	push cx
	    asm push dx

	    asm mov ax,3
	    asm Int 33H
	    asm mov siteX,cx
	    asm mov siteY,dx
	    asm mov buttons,bx

	    asm pop dx
	    asm pop cx
	    asm pop bx

#ifndef SHOW_MOUSE_POS
   if((lastSiteX != siteX) || (lastSiteY != siteY)){
      mouse_stamp=count;
    //  visible=TRUE;
    }
#endif

#ifdef SHOW_MOUSE_POS
  // if the mouse position has changed: draw it.
   if((lastSiteX != siteX) || (lastSiteY != siteY)){
      mouse_stamp=count;
   //   visible=TRUE;	// show buttons, position, mouse cursor etc.
      ::setwritemode(COPY_PUT);
    // erase old mouse position:
      int oldcolor=::getcolor();
      ::setcolor(BLACK);
      for(int i=50;i<75;i++){
	::line(50,i,75,i);
	};
    // draw new mouse coordinates:
      char OsiteX[4],OsiteY[4];
      itoa(siteX,OsiteX,10);
      itoa(siteY,OsiteY,10);
    ::setcolor(WHITE);
      outtextxy(50,50,OsiteX);
      outtextxy(50,65,OsiteY);
    ::setcolor(oldcolor);
    ::setwritemode(XOR_PUT);
   } // end if
#endif

  //    if(kbhit()){
	if(buttons&1){   // if left button pressed.
  //	 ch=getch();
  //	 visible=TRUE;
	 mouse_stamp=count;
	 Check_input(Xb,Yb,Zb,NXb,NYb,NZb,siteX,siteY);
	} //endif
     stamp_difference=count-mouse_stamp;
     if(stamp_difference >= MOUSE_DELAY){
	numOff++;
	if(numOff==0){
		hidesite();
		blank_buttons();
	  };
	numOn=-1;
      } else {
	numOn++;
	if(numOn==0){
		show_buttons();
		showsite();
	  };
	numOff=-1;
      };


      if(Xb==TRUE){
	  objectlist[0]->Apply(Rx);
	 }
	else if(NXb==TRUE)
	{
	  objectlist[0]->Apply(NRx);
	};

     if(Yb==TRUE){
	objectlist[0]->Apply(Ry);
      } else if(NYb==TRUE)
       {
	objectlist[0]->Apply(NRy);
       };

       if(Zb==TRUE){
	 objectlist[0]->Apply(Rz);
	} else if(NZb==TRUE)
	{
	 objectlist[0]->Apply(NRz);
	};

// create copies of graph objects before perspective projection (pi invariant)

#ifndef orthogonal
    copyList[0] = new graph(*objectlist[0]);
    if(count != 0){		// NOTE: count may run back to 0 at 65k
	hidesite();
	oldList[0]->Draw();
	showsite();
	delete oldList[0];
      };
#endif

#ifndef orthoganal
	 copyList[0]->Project();
#endif

#ifdef orthogonal
	hidesite();
	objectlist[0]->Draw();
	showsite();
#endif

#ifndef orthogonal
	 hidesite();
	 copyList[0]->Draw();
	 showsite();
#endif

#ifdef orthogonal
	 delay(DELAY);
#endif

#ifdef orthogonal
	 hidesite();
	 objectlist[0]->Draw();
	 showsite();
#endif

#ifndef orthogonal
	 oldList[0] = new graph(*copyList[0]);
#endif

#ifndef orthogonal
       delete copyList[0];
#endif
//#ifdef SHOW_MOUSE_POS
    lastSiteX=siteX;
    lastSiteY=siteY;
//#endif
     count++;

 }; // end while

  ::closegraph();
  printf("\n would you like to view another file ? (y/n) \n");
  outerch=getch();
  count2++;
  } while((outerch=='Y')||(outerch=='y'));
  printf("\n \n (c) EcktoSoft 1994. \n");
  printf("press a key to continue.");
  getch();
};

void  Check_input(BOOLEAN& Xb,BOOLEAN& Yb,BOOLEAN& Zb,
	BOOLEAN& NXb,BOOLEAN& NYb,BOOLEAN& NZb,unsigned sx,unsigned sy){
char ch='o'; // meaningless char.
// check to see if button-press is within x,y,z rot ranges.
// if button press is within the rectangular button area, find which
// rotation code to apply.
 if((sx>XMINB)&&(sx<XMAXB)&&(sy<YMAXB)&&(sy>YMINB)){
 // button press is definitely within x,y,z rotation area
 // find out which one:
    if(sy<MAXXROTY){  // definitely an x-rot, see if pos,or neg
      if(sx<PROTX){
	ch='Q';       // set opcode for negative x-rot
       } else {
	ch='q';	      // '' '' positive x-rot
       };
    } else
    if(sy<MAXYROTY){   // is a y-rot, find which one.
      if(sx<PROTX){
	ch='A';
       } else {
	ch='a';
       }
    } else	// at this point, it is a z-rot, find which one.
      if(sx<PROTX){
	ch='Z';
       } else {
	ch='z';
      };
  switch(ch){
	    case 'q' : { if(Xb==TRUE){Xb=FALSE;NXb=FALSE;
				  } else
			     { Xb=TRUE;NXb=FALSE; }; break;};

	    case 'Q' : { if(NXb==TRUE) {NXb=FALSE;Xb=FALSE;}
				 else{ NXb=TRUE; Xb=FALSE;};
				 break;};

	    case 'a' : { if(Yb==TRUE){Yb=FALSE;NYb=FALSE;
				  }else
				 { Yb=TRUE; NYb=FALSE;
				 }; break; }

	    case 'A' : { if(NYb==TRUE){NYb=FALSE;Yb=FALSE;
				 } else{ NYb=TRUE; Yb=FALSE; };
				 break; }

	    case 'z' : { if(Zb==TRUE){ Zb=FALSE;NZb=FALSE; }
				 else{ Zb=TRUE; NZb=FALSE;};
				 break;}

	    case 'Z' : { if(NZb==TRUE){NZb=FALSE;Zb=FALSE;
				 }
				 else{NZb=TRUE; Zb=FALSE;};
				 break;}
	   }; // end switch
   } // end outer if
}; // end func.

void show_buttons(void){
   ::setwritemode(XOR_PUT);
   ::setcolor(GREEN);
   ::rectangle(XMINB,YMINB,PROTX-1,MAXXROTY-1);
   ::rectangle(PROTX+1,YMINB,XMAXB+1,MAXXROTY-1);

   ::outtextxy(XMINB+XOFF,YMINB+YOFF,"X-");
   ::outtextxy(PROTX+XOFF,YMINB+YOFF,"X+");

   ::rectangle(XMINB,MAXXROTY+1,PROTX-1,MAXYROTY-1);
   ::rectangle(PROTX+1,MAXXROTY+1,XMAXB+1,MAXYROTY-1);

::outtextxy(XMINB+XOFF,MAXXROTY+YOFF,"Y-");
::outtextxy(PROTX+XOFF,MAXXROTY+YOFF,"Y+");

   ::rectangle(XMINB,MAXYROTY+1,PROTX-1,YMAXB);
   ::rectangle(PROTX+1,MAXYROTY+1,XMAXB+1,YMAXB);

::outtextxy(XMINB+XOFF,MAXYROTY+YOFF,"Z-");
::outtextxy(PROTX+XOFF,MAXYROTY+YOFF,"Z+");
};

void blank_buttons(void){
   ::setwritemode(COPY_PUT);
   int oldcolor=::getcolor();
   ::setcolor(BLACK);
   for(int i=0;i<XMAXB-XMINB+2;i++){
     ::line(i,YMINB,i,YMAXB);
   }
  ::setcolor(oldcolor);
  ::setwritemode(XOR_PUT);
};

/////////////////////////////////////////////////////////////////////////
// default constructor:
//	initializes resolution to default, sets up drawing apparatus
//	(A_grid), and allocates new graph object to store the construction.
grid::grid(){
     vector *tmp;
	Zcoordinate=1;     // starting zcoordinate of grid.
	X_res=DEF_GRID_X;
	Y_res=DEF_GRID_Y;
	float half_X_res_Scale=(X_res/2)*UNIT_VALUE; // offset from origin
	float half_Y_res_Scale=(Y_res/2)*UNIT_VALUE; // of outermost points.
	// instantiate new graph object with # of vertices, edges
	A_grid = new graph(X_res*Y_res,X_res+Y_res);
	A_grid->Tx=StandardTx;
	A_grid->Ty=StandardTy;
	// allocate memory for all vertices and edges and initialize them
	// with default 'grid' values.
    int index=0,edge_index=0;
    edge *temp1,*temp2;
  for(int i=0;i<X_res;i++){
   // vertical edges:
     temp1=new edge;
     temp1->from=i;
   for(int j=0;j<Y_res;j++){
     tmp = new vector(i*UNIT_VALUE-half_X_res_Scale,j*UNIT_VALUE-
	half_Y_res_Scale,Zcoordinate,1);
     A_grid->Insert_pt(tmp,index);
     index++;
    }
    temp1->to=index;
    A_grid->Insert_edge(temp1,edge_index);
   }
};
