// test of line-intersection function.

#include <graphics.h>
#include <conio.h>
#include <process.h>
#include <stdio.h>
#include <assert.h>

#define TRUE 1
#define FALSE 0

// #defines for codes for clip rectangle sides (for line-clip).
//   all numbers represent 4-bit codes.
#define TOP 8	 // 1st bit = outside halfplane of top edge, above top edge.
#define BOTTOM 4 // 2nd bit = below bottom edge.
#define RIGHT 2  // 3rd bit = right of right edge.
#define LEFT 1   // 4th bit = left of left edge.

typedef unsigned char BOOLEAN;

typedef struct {
	float x;
	float y;
} point;

typedef struct {
	point p0;
	point p1;
	unsigned char clipExtreme;
} ClipLine;

BOOLEAN Inside(point& testpoint,ClipLine& clipBoundary);
point Intersect(point first,point second,ClipLine edge);

void main(){
		int gdriver = DETECT, gmode, errorcode;
		// "d:\\borlandc\\bgi"
		initgraph(&gdriver, &gmode,"c:\\borlandc\\bgi");
		errorcode = graphresult();
		if (errorcode != grOk){
		   printf("Graphics error: %s\n", grapherrormsg(errorcode));
		   printf("Press any key to halt:");
		   getch();
		   exit(1);
		}
// clipping rectangle:
point upleft,dnright;

upleft.x=100; upleft.y=100;
dnright.x=400; dnright.y=400;

ClipLine Left,Right,Bottom,Top;
     Left.clipExtreme=LEFT;
	Left.p0.x=upleft.x;
	Left.p0.y=upleft.y;
	Left.p1.x=upleft.x;
	Left.p1.y=dnright.y;
     Right.clipExtreme=RIGHT;
	Right.p0.x=dnright.x;
	Right.p0.y=upleft.y;
	Right.p1.x=dnright.x;
	Right.p1.y=dnright.y;
     Bottom.clipExtreme=BOTTOM;
	Bottom.p0.x=upleft.x;
	Bottom.p0.y=dnright.y;
	Bottom.p1.x=dnright.x;
	Bottom.p1.y=dnright.y;
     Top.clipExtreme=TOP;
	Top.p0.x=upleft.x;
	Top.p0.y=upleft.y;
	Top.p1.x=dnright.x;
	Top.p1.y=upleft.y;

// intersection point:
point inter;

point end1,end2;

end1.x=250;  end2.x=50;
end1.y=250;  end2.y=50;

// draw clip boundary:
/*::setcolor(GREEN);
::line(Left.p0.x,Left.p0.y,Left.p1.x,Left.p1.y);
::line(Right.p0.x,Right.p0.y,Right.p1.x,Right.p1.y);
::line(Top.p0.x,Top.p0.y,Top.p1.x,Top.p1.y);
::line(Bottom.p0.x,Bottom.p0.y,Bottom.p1.x,Bottom.p1.y);
*/
setwritemode(XOR_PUT);
while(!kbhit()){
for(int i=0;i<400;i++){
       ::setcolor(GREEN);
       ::line(end1.x,end1.y,end2.x,end2.y);
       ::line(end1.x,end1.y,end2.x,end2.y);
       if((Inside(end1,Left)==TRUE)&&(Inside(end2,Left)==FALSE)){
       inter=Intersect(end1,end2,Left);
       ::putpixel(inter.x,inter.y,RED);
       };
       end2.y+=1;
     }
for(i=0;i<400;i++){
       ::setcolor(GREEN);
       ::line(end1.x,end1.y,end2.x,end2.y);
       ::line(end1.x,end1.y,end2.x,end2.y);
       if((Inside(end1,Bottom)==TRUE)&&(Inside(end2,Bottom)==FALSE)){
       inter=Intersect(end1,end2,Bottom);
       ::putpixel(inter.x,inter.y,YELLOW);
       };
       end2.x+=1;
     }
for(i=0;i<400;i++){
       ::setcolor(GREEN);
       ::line(end1.x,end1.y,end2.x,end2.y);
       ::line(end1.x,end1.y,end2.x,end2.y);
    if((Inside(end1,Right)==TRUE)&&(Inside(end2,Right)==FALSE)){
       inter=Intersect(end1,end2,Right);
       ::putpixel(inter.x,inter.y,MAGENTA);
       };
       end2.y-=1;
     }
for(i=0;i<400;i++){
       ::setcolor(GREEN);
       ::line(end1.x,end1.y,end2.x,end2.y);
       ::line(end1.x,end1.y,end2.x,end2.y);
     if((Inside(end1,Top)==TRUE)&&(Inside(end2,Top)==FALSE)){
       inter=Intersect(end1,end2,Top);
       ::putpixel(inter.x,inter.y,CYAN);
       };
       end2.x-=1;
     }
     ::cleardevice();
};
 ::closegraph();
};


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// Inside:: tests a point to see if it is within clip bounds.

BOOLEAN Inside(point& testpoint,ClipLine& clipBoundary){
	BOOLEAN retval=FALSE;
	float x=testpoint.x;
	float y=testpoint.y;

assert((clipBoundary.clipExtreme==TOP)||(clipBoundary.clipExtreme==BOTTOM)||
(clipBoundary.clipExtreme==LEFT)||(clipBoundary.clipExtreme==RIGHT));

      switch (clipBoundary.clipExtreme) {
       case TOP : { if( y > clipBoundary.p0.y ){
		     retval=TRUE; } break; }

       case BOTTOM : { if(y < clipBoundary.p0.y ){
		     retval=TRUE; } break; }

       case LEFT   : { if(x > clipBoundary.p0.x ){
		     retval=TRUE; } break; }

       case RIGHT  : { if(x < clipBoundary.p0.x ){
		     retval=TRUE; } break; }
       }  // endswitch
  return retval;
};



// Intersect, calculates intersection point of line with clipBoundary:

point Intersect(point first,point second,ClipLine edge){
	float x,y;
	float x0=first.x;
	float x1=second.x;
	float y0=first.y;
	float y1=second.y;

   switch(edge.clipExtreme){
     case LEFT : { y=y0+(y1-y0)*(edge.p0.x-x0)/(x1-x0);
		   x=edge.p0.x;
		   break; }
     case RIGHT : { y=y0+(y1-y0)*(edge.p0.x-x0)/(x1-x0);
		    x=edge.p0.x;
		    break; }
     case BOTTOM : { x=x0+(x1-x0)*(edge.p0.y - y0)/(y1-y0);
		     y=edge.p0.y;
		     break; }
     case TOP	 :  { x=x0+(x1-x0)*(edge.p0.y - y0)/(y1-y0);
		      y=edge.p0.y;
		      break; }
	} // endswitch
    point intersection;
    intersection.x=x;
    intersection.y=y;
    return intersection;
};  // end Intersect
