// Gregory Ecker
// point class member functions defined.
// version 1.a
// version 1.2 working
#include "point.h"

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// Apply : takes given matrix and changes *this object to dot product
// # 	   of the (vector and matrix).
void point::Apply(matrix& M){
	rep=rep*M;
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// assignment operator (point1=point2)
// #	maintains next pointer.

point& point::operator=(const point& p){
       rep[0]=p[0];
       rep[1]=p[1];
       rep[2]=p[2];
       rep[3]=p[3];
       id=p.Id();
       return *this;
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// assignment operator ( point=vector )
// #	maintains 'next' field.
point& point::operator=(const vector& v){
	rep[0]=v[0];
	rep[1]=v[1];
	rep[2]=v[2];
	rep[3]=v[3];
	return *this;
};

// scalar coordinates returned by following member functions.
//  ( along with [] operator )

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// cords() :  returns a vector which is a copy of the current
// #          point's vector.

vector point::coords(void) const{
	 vector tmp(rep);
	 return (tmp);
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

// constructors:

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// alternate constructor:
//   initializes new point to vector coord.s

point::point(const vector& v){
      rep[0]=v[0];
      rep[1]=v[1];
      rep[2]=v[2];
      rep[3]=v[3];
      id=NOTGROUPED;
      next = NULL;
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// copy constructor:
//  copies only vector coords, NOT 'next' field.

point::point(const point& p){
    rep[0] = p[0];
    rep[1] = p[1];
    rep[2] = p[2];
    rep[3] = p[3];
    next = NULL;
    id=p.Id();
};

// constructors:

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// initializes a new point to float parameters.
//  point's next field is set to the pt. (next point in list).

point::point(float x1,float y1,float z1,float W1,point* pt){
	rep[0]=x1;
	rep[1]=y1;
	rep[2]=z1;
	rep[3]=W1;

	id = NOTGROUPED;
	next = pt;
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// initializes a new point to float parameters.
//  point's next field is set to indicate single point ( NULL ).

point::point(float x1,float y1,float z1,float W1){
	rep[0]=x1;
	rep[1]=y1;
	rep[2]=z1;
	rep[3]=W1;

	id = NOTGROUPED;
	next = NULL;
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// initializes new point to normalized vector
// initializes 'next' field to indicate a single point.

point::point(){
	rep[0]=0.0;
	rep[1]=0.0;
	rep[2]=0.0;
	rep[3]=1.0;

	id = NOTGROUPED;
	next = NULL;
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

// overloaded operators

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// operator [] ; returns an lval (for assignment).
//     changes corresponding component within internal vector.

float& point::operator[](int i){
	assert((i<4) && (i>-1));  // check bounds of index.
	return( rep[i] );
};

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// operator [] const, returns an rval (not for assignement, const function.
//           returns corresponding component of internal vector.

float point::operator[](int i) const{
	   assert((i<4) && (i>-1));  // check bounds of index.
	   return( rep[i] );
};
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

